#include <uapi/linux/ptrace.h>
#include <linux/sched.h>

BPF_PERF_OUTPUT(events);
BPF_ARRAY(counters, u64, 1);

struct comm_t {
	char scomm[16];
	char ecomm[16];
};

TRACEPOINT_PROBE(sched, sched_wakeup) {
    struct comm_t comm;
    int zero = 0;
    u64 *val;

    val = counters.lookup(&zero);
    if (val)
	if (*val > 2000)
            return 0;

    memcpy(&comm.scomm, &args->comm, 16);
    memcpy(&comm.ecomm, &args->comm[8], 16);

    int rc;
    if ((rc = events.perf_submit(args, &comm, sizeof(comm))) < 0)
      bpf_trace_printk("perf_output failed: %d\n", rc);

    // could also use `stats.increment(key);`
    if (val) lock_xadd(val, 1);
    return 0;
}
