#!/usr/bin/python3

import time

import atexit
from bcc import BPF
from bcc.utils import printb
import ctypes as ct

class comms(ct.Structure):
    _fields_ = [("scomm", ct.c_char * 16),
                ("ecomm", ct.c_char * 16)]

counter = 0
def cb(cpu, data, size):
    event = ct.cast(data, ct.POINTER(comms)).contents

    print("should be correct: %16s - should be truncated: %16s" % (event.scomm.decode(), event.ecomm.decode()))

    global counter
    counter += 1

b = BPF(src_file="comm.c")
b["events"].open_perf_buffer(cb, page_cnt=32768)

@atexit.register
def print_counter():
    global counter
    global b
    print("counter = %d vs %d" % (counter, b["counters"][ct.c_int(0)].value))

print("Tracing...")

b.perf_buffer_poll(timeout=200)
